import glob
import os, json
os.environ["CUDA_VISIBLE_DEVICES"]="-1" 
import time
import tensorflow as tf
import numpy as np


def getAlf(num):   
    ABC = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
    return ABC[num]


run = True

modelO = tf.keras.models.load_model('jupyter/Saved_ModelOpen/93.915ANN')

while run:
    try:
        list_of_files = glob.glob('Openpose_RealTime/*') # * means all if need specific format then *.csv
        if(len(list_of_files)>0):
            latest_file = max(list_of_files, key=os.path.getctime)
            with open(latest_file) as json_file:

                data = json.load(json_file)
                temp_array = []
                if (len(data['people'])<1):
                    continue
                if (len(data['people'][0]['hand_right_keypoints_2d'])>0):
                    jsonIndex = 'hand_right_keypoints_2d'
                else:
                    jsonIndex = 'hand_left_keypoints_2d'
                if(data['people'][0][jsonIndex][0]==0  and data['people'][0][jsonIndex][0]==0):
                    continue
                for i in range (21):
                    index_corr = i*3
                    x_pos = data['people'][0][jsonIndex][0 + index_corr] - data['people'][0][jsonIndex][0]
                    y_pos = data['people'][0][jsonIndex][1 + index_corr] - data['people'][0][jsonIndex][1]
                    temp_array.append(float(x_pos))
                    temp_array.append(float(y_pos))
                print ('Predict: ' + getAlf(np.argmax(modelO.predict(np.array([temp_array])))))
            
        time.sleep(0.5)
    except BaseException:

        print(BaseException)